/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package model;

/**
 *
 * @author user
 */
public class Case {

    public static Runner run;
    public static ArgModel args = new ArgModel();
    public static String sModel = "models/default_rules.txt";
    public static String sState = "states/default_start_state.txt";
    
    public final static int t0 = 60;
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        case4();
    }
    
    
    public static void case1() {
        for (double p = 0; p <= 1; p += 0.01) {
            run = new Runner(
                new Model(sModel),
                new State("states/_old_default_state.txt")
            );

            run.model.pn = p;
            for (int i = 1; i <= t0; i++)
                run.step();

            int cars = run.state.numOfCars();
            double v = (cars > 0) ?
                Math.round(run.state.moved * 100.0 / cars) / 100.0 : 0;
            
            double pp = Math.round(p * 100.0) / 100.0;
            System.out.println(pp + " " + cars + " " + v);
//            if (pp == 0.15)
//                run.state.storeToFile("states/case1.txt");
        }
    }
    
    public static void case2() {
        for (int k = 0; k <= 30; k++) {
            State s = new State("states/_old_default_state.txt");

            for (int i = 1; i <= k; i++) {
                boolean set = false;
                while (!set) {
                    int r = (int)(Math.floor(Math.random() * s.n) + 1);
                    if (s.s[s.m][r] == 0) {
                        set = true;
                        s.s[s.m][r] = 2;
                    }
                }
            }
            s.storeToFile("states/case2_k.txt");

            double p = 0;
            double pp = 0;
            boolean jam = false;
            int cars = 0;
            
            while (!jam) {
                p += 0.01;
                run = new Runner(
                    new Model(sModel),
                    new State("states/case2_k.txt")
                );            

                run.model.pn = p;
                for (int i = 1; i <= t0; i++)
                    run.step();

                cars = run.state.numOfCars();
                double v = (cars > 0) ?
                    Math.round(run.state.moved * 100.0 / cars) / 100.0 : 0;
                pp = Math.round(p * 100.0) / 100.0;
                
                if ((cars > 10) && (v < 0.25)) jam = true;
                if (p >= 1) jam = true;
                
/*                if ((pp <= 0.02) && jam) {
                    run.state.storeToFile("states/case2_wtf.txt");
                    p = p / (pp - pp);
                } */
            }


            System.out.println(k + " " + pp + " " + cars);
        }        
    }

    public static void case3() {
        for (int i = 1; i <= 30; i++) {
        for (double p = 0.01; p <= 0.05; p += 0.01) {
            double pp = Math.round(p * 100.0) / 100.0;
            run = new Runner(
                new Model("models/dtp_" + pp + ".txt"),
                new State("states/_old_default_state.txt")
            );

            run.model.pn = 0.1;
            double v = 0.5;
            double vp = 0.5;
            while (v > 0.25 && vp > 0.25 && run.state.t < 100) {
                run.step();
                int cars = run.state.numOfCars();
                vp = v;
                v = (cars >= 10) ?
                    Math.round(run.state.moved * 100.0 / cars) / 100.0 : 0.5;
//                System.out.println(pp + " " + run.state.t + " " + cars + " " + v);
            }
            System.out.println(pp + " " + run.state.t);        
        }
        }

    }
    
    
    public static void case4() {
        run = new Runner(
            new Model("models/dtp_0.02.txt"),
            new State("states/_old_default_state.txt")
        );

        run.model.pn = 0.1;
        for (int i = 1; i <= 30; i++)
            run.step();
        
        for (int i = 31; i <= 90; i++) {
            run.step();
            int cars = run.state.numOfCars();
            int breaks = run.state.numOfBreaks();
            double v = (cars >= 0) ?
                Math.round(run.state.moved * 100.0 / cars) / 100.0 : 0;
            System.out.println(run.state.t + " " + v + " " + cars + " " + breaks);
        }
        run.state.storeToFile("states/case4.txt");

    }
    
}
